Index: /branches/OptimizationNetworks/HeuristicLab.CodeEditor/3.3/CodeEditor.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.CodeEditor/3.3/CodeEditor.cs	(revision 11564)
+++ /branches/OptimizationNetworks/HeuristicLab.CodeEditor/3.3/CodeEditor.cs	(revision 11565)
@@ -26,4 +26,7 @@
 // OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
+using HeuristicLab.Common.Resources;
+using ICSharpCode.TextEditor;
+using ICSharpCode.TextEditor.Document;
 using System;
 using System.CodeDom.Compiler;
@@ -35,7 +38,4 @@
 using System.Threading;
 using System.Windows.Forms;
-using HeuristicLab.Common.Resources;
-using ICSharpCode.TextEditor;
-using ICSharpCode.TextEditor.Document;
 using Dom = ICSharpCode.SharpDevelop.Dom;
 using NRefactory = ICSharpCode.NRefactory;
@@ -131,4 +131,9 @@
         Doc.CommitUpdate();
       }
+    }
+
+    public bool ReadOnly {
+      get { return Doc.ReadOnly; }
+      set { Doc.ReadOnly = value; }
     }
 
Index: /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/Core.Networks.Views/UserDefinedNetworkView.Designer.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/Core.Networks.Views/UserDefinedNetworkView.Designer.cs	(revision 11564)
+++ /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/Core.Networks.Views/UserDefinedNetworkView.Designer.cs	(revision 11565)
@@ -47,8 +47,10 @@
       this.codeTabPage = new System.Windows.Forms.TabPage();
       this.programmableItemView = new HeuristicLab.Core.Views.ProgrammableItemView();
+      this.initializeButton = new System.Windows.Forms.Button();
       this.tabControl.SuspendLayout();
       this.nodesTabPage.SuspendLayout();
       this.portsTabPage.SuspendLayout();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
+      this.codeTabPage.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -67,4 +69,5 @@
       // codeTabPage
       // 
+      this.codeTabPage.Controls.Add(this.initializeButton);
       this.codeTabPage.Controls.Add(this.programmableItemView);
       this.codeTabPage.Location = new System.Drawing.Point(4, 22);
@@ -80,9 +83,20 @@
       this.programmableItemView.Content = null;
       this.programmableItemView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.programmableItemView.Location = new System.Drawing.Point(3, 3);
+      this.programmableItemView.Location = new System.Drawing.Point(0, 0);
       this.programmableItemView.Name = "programmableItemView";
       this.programmableItemView.ReadOnly = false;
-      this.programmableItemView.Size = new System.Drawing.Size(631, 459);
+      this.programmableItemView.Size = new System.Drawing.Size(637, 465);
       this.programmableItemView.TabIndex = 0;
+      // 
+      // initializeButton
+      // 
+      this.initializeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Refresh;
+      this.initializeButton.Location = new System.Drawing.Point(33, 3);
+      this.initializeButton.Name = "initializeButton";
+      this.initializeButton.Size = new System.Drawing.Size(24, 24);
+      this.initializeButton.TabIndex = 1;
+      this.toolTip.SetToolTip(this.initializeButton, "Initialize");
+      this.initializeButton.UseVisualStyleBackColor = true;
+      this.initializeButton.Click += new System.EventHandler(this.initializeButton_Click);
       // 
       // UserDefinedNetworkView
@@ -93,4 +107,5 @@
       this.portsTabPage.ResumeLayout(false);
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
+      this.codeTabPage.ResumeLayout(false);
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -102,4 +117,5 @@
     protected System.Windows.Forms.TabPage codeTabPage;
     protected HeuristicLab.Core.Views.ProgrammableItemView programmableItemView;
+    protected System.Windows.Forms.Button initializeButton;
   }
 }
Index: /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/Core.Networks.Views/UserDefinedNetworkView.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/Core.Networks.Views/UserDefinedNetworkView.cs	(revision 11564)
+++ /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/Core.Networks.Views/UserDefinedNetworkView.cs	(revision 11565)
@@ -43,4 +43,13 @@
       programmableItemView.Content = Content;
     }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      initializeButton.Enabled = Content != null && !ReadOnly && !Locked;
+    }
+
+    private void initializeButton_Click(object sender, System.EventArgs e) {
+      Content.Initialize();
+    }
   }
 }
Index: /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/Core.Networks.Views/UserDefinedNodeView.Designer.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/Core.Networks.Views/UserDefinedNodeView.Designer.cs	(revision 11564)
+++ /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/Core.Networks.Views/UserDefinedNodeView.Designer.cs	(revision 11565)
@@ -47,10 +47,12 @@
       this.tabControl = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.portsTabPage = new System.Windows.Forms.TabPage();
+      this.portCollectionView = new HeuristicLab.Core.Networks.Views.PortCollectionView();
       this.codeTabPage = new System.Windows.Forms.TabPage();
-      this.portCollectionView = new HeuristicLab.Core.Networks.Views.PortCollectionView();
       this.programmableItemView = new HeuristicLab.Core.Views.ProgrammableItemView();
+      this.initializeButton = new System.Windows.Forms.Button();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.tabControl.SuspendLayout();
       this.portsTabPage.SuspendLayout();
+      this.codeTabPage.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -85,15 +87,4 @@
       this.portsTabPage.UseVisualStyleBackColor = true;
       // 
-      // codeTabPage
-      // 
-      this.codeTabPage.Controls.Add(this.programmableItemView);
-      this.codeTabPage.Location = new System.Drawing.Point(4, 22);
-      this.codeTabPage.Name = "codeTabPage";
-      this.codeTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.codeTabPage.Size = new System.Drawing.Size(637, 465);
-      this.codeTabPage.TabIndex = 1;
-      this.codeTabPage.Text = "Code";
-      this.codeTabPage.UseVisualStyleBackColor = true;
-      // 
       // portCollectionView
       // 
@@ -108,4 +99,16 @@
       this.portCollectionView.TabIndex = 0;
       // 
+      // codeTabPage
+      // 
+      this.codeTabPage.Controls.Add(this.initializeButton);
+      this.codeTabPage.Controls.Add(this.programmableItemView);
+      this.codeTabPage.Location = new System.Drawing.Point(4, 22);
+      this.codeTabPage.Name = "codeTabPage";
+      this.codeTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.codeTabPage.Size = new System.Drawing.Size(637, 465);
+      this.codeTabPage.TabIndex = 1;
+      this.codeTabPage.Text = "Code";
+      this.codeTabPage.UseVisualStyleBackColor = true;
+      // 
       // programmableItemView
       // 
@@ -118,4 +121,15 @@
       this.programmableItemView.Size = new System.Drawing.Size(631, 459);
       this.programmableItemView.TabIndex = 0;
+      // 
+      // initializeButton
+      // 
+      this.initializeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Refresh;
+      this.initializeButton.Location = new System.Drawing.Point(36, 6);
+      this.initializeButton.Name = "initializeButton";
+      this.initializeButton.Size = new System.Drawing.Size(24, 24);
+      this.initializeButton.TabIndex = 1;
+      this.toolTip.SetToolTip(this.initializeButton, "Initialize");
+      this.initializeButton.UseVisualStyleBackColor = true;
+      this.initializeButton.Click += new System.EventHandler(this.initializeButton_Click);
       // 
       // UserDefinedNodeView
@@ -130,4 +144,5 @@
       this.tabControl.ResumeLayout(false);
       this.portsTabPage.ResumeLayout(false);
+      this.codeTabPage.ResumeLayout(false);
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -142,4 +157,5 @@
     protected System.Windows.Forms.TabPage codeTabPage;
     protected HeuristicLab.Core.Views.ProgrammableItemView programmableItemView;
+    protected System.Windows.Forms.Button initializeButton;
 
   }
Index: /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/Core.Networks.Views/UserDefinedNodeView.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/Core.Networks.Views/UserDefinedNodeView.cs	(revision 11564)
+++ /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/Core.Networks.Views/UserDefinedNodeView.cs	(revision 11565)
@@ -42,4 +42,13 @@
       programmableItemView.Content = Content;
     }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      initializeButton.Enabled = Content != null && !ReadOnly && !Locked;
+    }
+
+    private void initializeButton_Click(object sender, System.EventArgs e) {
+      Content.Initialize();
+    }
   }
 }
Index: /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/Core.Views/ProgrammableItemView.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/Core.Views/ProgrammableItemView.cs	(revision 11564)
+++ /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/Core.Views/ProgrammableItemView.cs	(revision 11565)
@@ -21,5 +21,4 @@
 
 using HeuristicLab.Common.Resources;
-using HeuristicLab.Core.Views;
 using HeuristicLab.MainForm;
 using HeuristicLab.PluginInfrastructure;
@@ -71,6 +70,7 @@
     protected override void SetEnabledStateOfControls() {
       base.SetEnabledStateOfControls();
-      compileButton.Enabled = Content != null && !Locked && !ReadOnly;
-      codeEditor.Enabled = Content != null;
+      compileButton.Enabled = Content != null && Content.CanChangeCode && !Locked && !ReadOnly;
+      codeEditor.Enabled = Content != null && !Locked;
+      codeEditor.ReadOnly = ReadOnly || Locked || ((Content != null) && !Content.CanChangeCode);
     }
 
@@ -97,5 +97,5 @@
     }
     private void codeEditor_Validated(object sender, EventArgs e) {
-      if (Content != null) Content.Code = codeEditor.UserCode;
+      if ((Content != null) && Content.CanChangeCode) Content.Code = codeEditor.UserCode;
     }
     private void errorsListView_DoubleClick(object sender, EventArgs e) {
Index: /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/IUserDefinedNetwork.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/IUserDefinedNetwork.cs	(revision 11564)
+++ /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/IUserDefinedNetwork.cs	(revision 11565)
@@ -24,4 +24,6 @@
     new PortCollection Ports { get; }
     new NodeCollection Nodes { get; }
+
+    void Initialize();
   }
 }
Index: /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/IUserDefinedNode.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/IUserDefinedNode.cs	(revision 11564)
+++ /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/IUserDefinedNode.cs	(revision 11565)
@@ -23,4 +23,6 @@
   public interface IUserDefinedNode : IProgrammableNode {
     new PortCollection Ports { get; }
+
+    void Initialize();
   }
 }
Index: /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/ProgrammableNetwork.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/ProgrammableNetwork.cs	(revision 11564)
+++ /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/ProgrammableNetwork.cs	(revision 11565)
@@ -103,4 +103,9 @@
       }
 
+      public override void Initialize() {
+        base.Initialize();
+        Nodes.Clear();
+      }
+
       #region Events
       public override void RegisterEvents() {
Index: /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/ProgrammableNetworkItem.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/ProgrammableNetworkItem.cs	(revision 11564)
+++ /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/ProgrammableNetworkItem.cs	(revision 11565)
@@ -100,5 +100,4 @@
       get { return ReadCodeTemplate("HeuristicLab.Optimization.Networks.Core.Networks.ProgrammableNetworkItemTemplate.cs"); }
     }
-
     [Storable]
     private string code;
@@ -106,4 +105,5 @@
       get { return code; }
       set {
+        if (!CanChangeCode) throw new NotSupportedException("Code cannot be changed.");
         if (value != code) {
           code = value;
@@ -112,5 +112,4 @@
       }
     }
-
     private CompilerErrorCollection compileErrors;
     public CompilerErrorCollection CompileErrors {
@@ -120,4 +119,7 @@
         OnCompileErrorsChanged();
       }
+    }
+    public virtual bool CanChangeCode {
+      get { return false; }
     }
 
Index: /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/ProgrammableNode.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/ProgrammableNode.cs	(revision 11564)
+++ /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/ProgrammableNode.cs	(revision 11565)
@@ -119,4 +119,9 @@
       }
 
+      public override void Initialize() {
+        base.Initialize();
+        Ports.Clear();
+      }
+
       protected virtual void MessagePort_MessageReceived(object sender, EventArgs<IMessage, CancellationToken> e) { }
 
Index: /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/UserDefinedNetwork.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/UserDefinedNetwork.cs	(revision 11564)
+++ /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/UserDefinedNetwork.cs	(revision 11565)
@@ -34,4 +34,7 @@
       get { return base.Nodes; }
     }
+    public override bool CanChangeCode {
+      get { return true; }
+    }
 
     [StorableConstructor]
@@ -45,4 +48,10 @@
       return new UserDefinedNetwork(this, cloner);
     }
+
+    public void Initialize() {
+      CompiledNetworkItem.DeregisterEvents();
+      CompiledNetworkItem.Initialize();
+      CompiledNetworkItem.RegisterEvents();
+    }
   }
 }
Index: /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/UserDefinedNode.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/UserDefinedNode.cs	(revision 11564)
+++ /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/UserDefinedNode.cs	(revision 11565)
@@ -30,4 +30,7 @@
       get { return base.Ports; }
     }
+    public override bool CanChangeCode {
+      get { return true; }
+    }
 
     [StorableConstructor]
@@ -41,4 +44,10 @@
       return new UserDefinedNode(this, cloner);
     }
+
+    public void Initialize() {
+      CompiledNetworkItem.DeregisterEvents();
+      CompiledNetworkItem.Initialize();
+      CompiledNetworkItem.RegisterEvents();
+    }
   }
 }
Index: /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core/IProgrammableItem.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core/IProgrammableItem.cs	(revision 11564)
+++ /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core/IProgrammableItem.cs	(revision 11565)
@@ -29,4 +29,5 @@
     string Code { get; set; }
     CompilerErrorCollection CompileErrors { get; }
+    bool CanChangeCode { get; }
 
     void Compile();
Index: /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/HeuristicLab.Optimization.Networks-3.3.csproj
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/HeuristicLab.Optimization.Networks-3.3.csproj	(revision 11564)
+++ /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/HeuristicLab.Optimization.Networks-3.3.csproj	(revision 11565)
@@ -153,9 +153,4 @@
   </ItemGroup>
   <ItemGroup>
-    <ProjectReference Include="..\..\HeuristicLab.Algorithms.GeneticAlgorithm\3.3\HeuristicLab.Algorithms.GeneticAlgorithm-3.3.csproj">
-      <Project>{a51da44f-cb35-4f6f-99f5-2a2e904ab93b}</Project>
-      <Name>HeuristicLab.Algorithms.GeneticAlgorithm-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
       <Project>{958b43bc-cc5c-4fa2-8628-2b3b01d890b6}</Project>
@@ -183,14 +178,4 @@
       <Private>False</Private>
     </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Encodings.BinaryVectorEncoding\3.3\HeuristicLab.Encodings.BinaryVectorEncoding-3.3.csproj">
-      <Project>{66d249c3-a01d-42a8-82a2-919bc8ec3d83}</Project>
-      <Name>HeuristicLab.Encodings.BinaryVectorEncoding-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Encodings.PermutationEncoding\3.3\HeuristicLab.Encodings.PermutationEncoding-3.3.csproj">
-      <Project>{dbecb8b0-b166-4133-baf1-ed67c3fd7fca}</Project>
-      <Name>HeuristicLab.Encodings.PermutationEncoding-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Operators\3.3\HeuristicLab.Operators-3.3.csproj">
       <Project>{23da7ff4-d5b8-41b6-aa96-f0561d24f3ee}</Project>
@@ -216,19 +201,4 @@
       <Project>{94186a6a-5176-4402-ae83-886557b53cca}</Project>
       <Name>HeuristicLab.PluginInfrastructure-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Problems.Instances\3.3\HeuristicLab.Problems.Instances-3.3.csproj">
-      <Project>{3540e29e-4793-49e7-8ee2-fea7f61c3994}</Project>
-      <Name>HeuristicLab.Problems.Instances-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Problems.Knapsack\3.3\HeuristicLab.Problems.Knapsack-3.3.csproj">
-      <Project>{e10f395f-c8a6-48ad-b470-9aa7a1f43809}</Project>
-      <Name>HeuristicLab.Problems.Knapsack-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Problems.TravelingSalesman\3.3\HeuristicLab.Problems.TravelingSalesman-3.3.csproj">
-      <Project>{d767c38d-8014-46b0-9a32-03a3aecce34a}</Project>
-      <Name>HeuristicLab.Problems.TravelingSalesman-3.3</Name>
       <Private>False</Private>
     </ProjectReference>
Index: /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Optimization.Networks.KSPTSP/KSPTSPConnectorCode.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Optimization.Networks.KSPTSP/KSPTSPConnectorCode.cs	(revision 11564)
+++ /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Optimization.Networks.KSPTSP/KSPTSPConnectorCode.cs	(revision 11565)
@@ -28,4 +28,5 @@
 using System.Drawing;
 using System.Linq;
+using System.Threading;
 
 namespace HeuristicLab.Optimization.Networks.KSPTSP {
@@ -48,4 +49,5 @@
 
     public override void Initialize() {
+      base.Initialize();
       var parameters = new MessagePort("Parameters");
       Ports.Add(parameters);
@@ -78,5 +80,5 @@
     }
 
-    private void Knapsack_MessageReceived(object sender, EventArgs<IMessage, System.Threading.CancellationToken> e) {
+    private void Knapsack_MessageReceived(object sender, EventArgs<IMessage, CancellationToken> e) {
       // get parameters
       var parametersPort = (IMessagePort)Ports["Parameters"];
Index: /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Optimization.Networks.KSPTSP/KSPTSPNetworkCode.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Optimization.Networks.KSPTSP/KSPTSPNetworkCode.cs	(revision 11564)
+++ /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Optimization.Networks.KSPTSP/KSPTSPNetworkCode.cs	(revision 11565)
@@ -53,4 +53,6 @@
 
     public override void Initialize() {
+      base.Initialize();
+
       #region ParametersNode
       var paramsNode = new UserDefinedNode("ParametersNode");
Index: /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Plugin.cs.frame
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Plugin.cs.frame	(revision 11564)
+++ /branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Plugin.cs.frame	(revision 11565)
@@ -28,5 +28,4 @@
   [Plugin("HeuristicLab.Optimization.Networks", "3.3.11.$WCREV$")]
   [PluginFile("HeuristicLab.Optimization.Networks-3.3.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Algorithms.GeneticAlgorithm", "3.3")]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
   [PluginDependency("HeuristicLab.Common", "3.3")]
@@ -34,12 +33,8 @@
   [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Data", "3.3")]
-  [PluginDependency("HeuristicLab.Encodings.BinaryVectorEncoding", "3.3")]
-  [PluginDependency("HeuristicLab.Encodings.PermutationEncoding", "3.3")]
   [PluginDependency("HeuristicLab.Operators", "3.3")]
   [PluginDependency("HeuristicLab.Optimization", "3.3")]
   [PluginDependency("HeuristicLab.Parameters", "3.3")]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
-  [PluginDependency("HeuristicLab.Problems.Knapsack", "3.3")]
-  [PluginDependency("HeuristicLab.Problems.TravelingSalesman", "3.3")]
   public class HeuristicLabOptimizationNetworksPlugin : PluginBase {
   }