Index: /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AlpsGeneticAlgorithm.cs
===================================================================
--- /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AlpsGeneticAlgorithm.cs	(revision 11567)
+++ /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AlpsGeneticAlgorithm.cs	(revision 11567)
@@ -0,0 +1,68 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.ALPS {
+  [Item("ALPS Genetic Algorithm", "A genetic algorithm with an age-layered population structure.")]
+  [Creatable("Algorithms")]
+  [StorableClass]
+  public class AlpsGeneticAlgorithm : HeuristicOptimizationEngineAlgorithm, IStorableContent {
+    public string Filename { get; set; }
+
+    #region Problem Properties
+    public override Type ProblemType {
+      get { return typeof(ISingleObjectiveHeuristicOptimizationProblem); }
+    }
+    public new ISingleObjectiveHeuristicOptimizationProblem Problem {
+      get { return (ISingleObjectiveHeuristicOptimizationProblem)base.Problem; }
+      set { base.Problem = value; }
+    }
+    #endregion
+
+    #region Parameter Properties
+    #endregion
+
+    #region Properties
+    #endregion
+
+    [StorableConstructor]
+    private AlpsGeneticAlgorithm(bool deserializing)
+      : base(deserializing) { }
+
+    private AlpsGeneticAlgorithm(AlpsGeneticAlgorithm original, Cloner cloner)
+      : base(original, cloner) {
+      // TODO
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new AlpsGeneticAlgorithm(this, cloner);
+    }
+
+    public AlpsGeneticAlgorithm()
+      : base() {
+      // TODO
+    }
+  }
+}
Index: /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/HeuristicLab.Algorithms.ALPS-3.3.csproj
===================================================================
--- /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/HeuristicLab.Algorithms.ALPS-3.3.csproj	(revision 11566)
+++ /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/HeuristicLab.Algorithms.ALPS-3.3.csproj	(revision 11567)
@@ -77,4 +77,5 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="AlpsGeneticAlgorithm.cs" />
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
Index: /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Plugin.cs.frame
===================================================================
--- /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Plugin.cs.frame	(revision 11566)
+++ /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Plugin.cs.frame	(revision 11567)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Algorithms.ALPS plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Algorithms.ALPS", "3.3.10.$WCREV$")]
+  [Plugin("HeuristicLab.Algorithms.ALPS", "Provides the Age-Layered Population Structure (ALPS) as described in Gregory S. Hornby. 2006. ALPS: the age-layered population structure for reducing the problem of premature convergence. In Proceedings of the 8th annual conference on Genetic and evolutionary computation (GECCO '06). 815-822.", "3.3.10.$WCREV$")]
   [PluginFile("HeuristicLab.Algorithms.ALPS-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]